Index: libcfs/include/libcfs/libcfs.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/libcfs.h,v
retrieving revision 1.12
diff -u -p -r1.12 libcfs.h
--- libcfs/include/libcfs/libcfs.h	1 Dec 2009 02:23:42 -0000	1.12
+++ libcfs/include/libcfs/libcfs.h	1 Jan 2010 20:03:31 -0000
@@ -37,6 +37,157 @@
 #ifndef __LIBCFS_LIBCFS_H__
 #define __LIBCFS_LIBCFS_H__
 
+/**
+ * \defgroup libcfs Libcfs
+ *
+ * The Lustre library of data types, routines and macros of common use.
+ *
+ * Libcfs is a key component of Lustre file-system abstracting other
+ * components form peculiarities of operation environment like memory
+ * allocation, synchronization and logging facilities.
+ * @{
+ */
+
+/**
+ * \defgroup libcfs_types Generic types
+ *
+ * Generic integer and pointer-based types and primitives for swabbing.
+ *
+ * Libcfs replenishes the lack of generic type definitions (like __u64
+ * and long_ptr_t) on some platforms defining them in
+ * platform-specific libcfs headers. It also defines macros for
+ * endianness conversion (like __swab32, le32_to_cpu and many others)
+ * on platforms where such macros are not present in system headers.
+ */
+
+/**
+ * \defgroup libcfs_procfs Proc file system and sysctl
+ *
+ * Generic API for manipulating /proc entries and sysctl tables
+ *
+ * 1. /proc API
+ *
+ * The API includes:
+ * - types of read and write callbacks that are called from kernel
+ * when user reads from or writes to some file under /proc subtree
+ * (\a cfs_read_proc_t and \a cfs_write_proc_t)
+ * - type describing /proc entry itself (\a cfs_proc_dir_entry_t)
+ * - primitives to register and unregister an entry
+ * (\a cfs_create_proc_entry and \a cfs_remove_proc_entry)
+ * - primitive to free unused entry (\a cfs_free_proc_entry).
+ *
+ * Using this API, the consumer implements read and/or write
+ * callbacks and register entry with \a cfs_create_proc_entry that
+ * returns the pointer to newly created entry of \a cfs_proc_dir_entry_t
+ * type. Then, the consumer assigns its read and write callbacks to
+ * \a read_proc and \a write_proc fields of the entry correspondingly.
+ *
+ * To delete an entry from /proc and free it, the consumer must use
+ * \a cfs_remove_proc_entry. \a cfs_free_proc_entry is dangerous and
+ * should never be used directly.
+ *
+ * 2. sysctl API
+ *
+ * The API includes:
+ * - type describing sysctl table itself (\a cfs_sysctl_table_t)
+ * - type to be used as handle for registered sysctl table
+ * (\a cfs_sysctl_table_header_t)
+ * - primitives to register and unregister sysctl table
+ * (\a cfs_register_sysctl_table and \a cfs_unregister_sysctl_table)
+ * - macro alleviating definitions of sysctl callbacks
+ * (\a LL_PROC_PROTO)
+ *
+ * Using this API, the consumer implements sysctl callback starting
+ * implementation from "int LL_PROC_PROTO(name_of_callback) {". Then,
+ * defines sysctl table of \a cfs_sysctl_table_t type enumerating its
+ * elements one by one. Usually, each element at least specifies the
+ * address of data (on which given sysctl will operate) and
+ * correspondent callback to handle read/write operation (what was
+ * implemented with \a LL_PROC_PROTO macro).
+ *
+ * Having sysctl table defined, the consumer makes it visible for
+ * users by calling \a cfs_register_sysctl_table. It returns a pointer
+ * to \a cfs_sysctl_table_header_t (i.e. the handle of this sysctl
+ * table) that may be used later as argument for
+ * \a cfs_unregister_sysctl_table to remove given sysctl table from
+ * the system.
+ */
+
+/**
+ * \defgroup libcfs_lwt Light-weight tracing
+ *
+ * Support for temporary event tracing with minimal Heisenberg effect
+ *
+ * This facility was designed to allow developers to trace arbitrary
+ * events of interest minimizing the impact of tracing itself on
+ * behavior of the system.
+ *
+ * To use this facility, a developer should add \a LWT_EVENT probes
+ * into some parts of code that need tracing and recompile Lustre
+ * changing "#define LWT_SUPPORT  0" to "#define LWT_SUPPORT  1" in
+ * platform-specific libcfs headers. Then, the developer may use LWT
+ * ioctl-s to enable LWT, gather events and observe them:
+ * - IOC_LIBCFS_LWT_CONTROL
+ * - IOC_LIBCFS_LWT_SNAPSHOT
+ * - IOC_LIBCFS_LWT_LOOKUP_STRING.
+
+ * This facility is meant for finding specific problems and should
+ * never stay in production code.
+ */
+
+/**
+ * \defgroup libcfs_watchdog Watchdogs
+ *
+ * Watchdog facility of Libcfs.
+ *
+ * Libcfs watchdog is a device that allows caller to control whether some
+ * action is performed in timely manner. A consumer interested in
+ * such a control usually creates a watchdog at initialization time,
+ * enables it before start to perform an action specifying \a timeout for
+ * given action, then disables watchdog when processing finished. If
+ * action takes more than \a timeout seconds, Libcfs triggers watchdog
+ * calling consumer-defined callback and dumps lustre logs to a
+ * file. It's responsibility of caller to "touch" or disable watchdog
+ * when the action completed to avoid false triggering.
+ *
+ * If consumer didn't specify callback, the default one would be
+ * called after triggering watchdog. It prints out stack-trace of task
+ * that created watchdog (if possible). The consumer may reuse
+ * existing watchdog without recreation by means of re-enabling
+ * ("touching") it. The consumer usually deletes the watchdog at
+ * finalization time.
+ *
+ * NOTE: Libcfs provides watchdog facility only for in-kernel users.
+ *
+ * Libcfs watchdog is represented by lc_watchdog structure which
+ * implementation is hidden from consumer in watchdog.c. The consumer
+ * uses a pointer to libcfs watchdog as the handle for all operations
+ * on watchdog:
+ * - lc_watchdog_add - creating watchdog
+ * - lc_watchdog_touch - enabling watchdog
+ * - lc_watchdog_disable - disabling watchdog
+ * - lc_watchdog_delete - destroying watchdog
+ *
+ * Internally, libcfs watchdog may be in one of three states:
+ * - ENABLED - Libcfs armed watchdog and ready to trigger it if
+ * consumer won't touch or disable it before \a timeout expires
+ * - DISABLED - watchdog is turned off, Libcfs doesn't pay attention
+ * to it anymore
+ * - EXPIRED - watchdog was triggered, lustre logs dumped, callback
+ * called, Libcfs doesn't pay attention to this watchdog anymore.
+ *
+ * State transitions happen as follows:
+ * - upon creation (lc_watchdog_add), watchdog is in DISABLED state
+ * - being in DISABLED or EXPIRED state, the state is switched to
+ * ENABLED on lc_watchdog_touch call.
+ * - being in ENABLED or EXPIRED state, the state is switched to
+ * DISABLED on lc_watchdog_disable call.
+ * - being in ENABLED state, the state is switched to EXPIRED if
+ * \a timeout lapsed.
+ */
+
+/** \addtogroup libcfs_misc
+ * @{ */
 #if !__GNUC__
 #define __attribute__(x)
 #endif
@@ -56,6 +207,10 @@
 #include "curproc.h"
 
 #ifndef offsetof
+/**
+ * Calculates offset (in bytes) of field \a memb of type (usually
+ *  struct) \a typ counting from the beginning of \a typ.
+ */
 # define offsetof(typ,memb) ((long)(long_ptr_t)((char *)&(((typ *)0)->memb)))
 #endif
 
@@ -64,8 +219,11 @@
 #endif
 
 #if !defined(container_of)
-/* given a pointer @ptr to the field @member embedded into type (usually
- * struct) @type, return pointer to the embedding instance of @type. */
+/**
+ *  Given a pointer \a ptr to the field \a member embedded into type
+ *  (usually struct) \a type, returns pointer to the embedding
+ *  instance of \a type.
+ */
 #define container_of(ptr, type, member) \
         ((type *)((char *)(ptr)-(char *)(&((type *)0)->member)))
 #endif
@@ -75,11 +233,12 @@ static inline int __is_po2(unsigned long
         return !(val & (val - 1));
 }
 
+/** \return TRUE if and only if \a val is power of two */
 #define IS_PO2(val) __is_po2((unsigned long long)(val))
 
 #define LOWEST_BIT_SET(x)       ((x) & ~((x) - 1))
 
-/*
+/**
  * Lustre Error Checksum: calculates checksum
  * of Hex number by XORing each bit.
  */
@@ -87,7 +246,7 @@ static inline int __is_po2(unsigned long
                            ((hexnum) >> 8 & 0xf))
 
 
-/*
+/**
  * Some (nomina odiosa sunt) platforms define NULL as naked 0. This confuses
  * Lustre RETURN(NULL) macro.
  */
@@ -97,14 +256,72 @@ static inline int __is_po2(unsigned long
 
 #define NULL ((void *)0)
 
+/** Well-known LNET PID (of lnet_pid_t type) that all Lustre servers share */
 #define LUSTRE_SRV_LNET_PID      LUSTRE_LNET_PID
 
+/** @} libcfs_misc */
+
+/**
+ * \defgroup libcfs_net Network API
+ *
+ * Generic API for IP and TCP/IP.
+ *
+ * This API consists of three parts:
+ *
+ * 1. Enumerating and querying IP interfaces
+ *
+ * The only consumers of this part are LNDs who need to bind its
+ * instance to IP-address having IP-interface name externally
+ * provided. The API allows to build the table of names of all known
+ * interfaces (what we can see in 'ifconfig -a' output) and query
+ * every particular interface (specified by name) for its properties
+ * like IP-address, net-mask, etc.
+ *
+ * 2. Manipulating TCP/IP sockets
+ *
+ * This part abstracts some operations on TCP/IP sockets allowing LNET
+ * to implement connection establishment routines in generic way
+ * (i.e. hiding platform-specific details). Operations includes:
+ * - listen/connect/accept
+ * - setting and querying socket properties (namely, RX and TX socket
+ * buffer sizes)
+ * - read/write data from/to socket
+ * - release socket (no creation op provided, because listen/connect
+ * creates it internally)
+ *
+ * NOTE: read/write ops are blocking. LNET uses them only during
+ * connection establishment phase (including hello handshake). For
+ * subsequent data transfers, it employs more subtle,
+ * platform-specific techniques. An exception is usocklnd that enables
+ * non-blocking explicitly with libcfs_fcntl_nonblock and uses
+ * scatter-gather versions of libcfs read/write ops for all purposes.
+ *
+ * 3. A few auxiliary macros for easy printing IP-addresses: NIPQUAD and HIPQUAD
+ *
+ * NIPQUAD is for IP-addresses stored in network byte-order, HIPQUAD -
+ * for host byte-order. Typical usage is:
+ *
+ * CDEBUG(D_NET, "ip: %u.%u.%u.%u\n", HIPQUAD(ipaddr)); // __u32 ipaddr;
+ *
+ * @{
+ * \defgroup libcfs_kernel_net Network API (kernel-space)
+ *
+ * See \ref libcfs_net for generic description.
+ */
+/** @} libcfs_net */
+
 #ifdef __KERNEL__
 
 #include <libcfs/list.h>
 
-/* for_each_possible_cpu is defined newly, the former is
- * for_each_cpu(eg. sles9 and sles10) b=15878 */
+/*
+ * for_each_possible_cpu is defined newly, the former is
+ * for_each_cpu(eg. sles9 and sles10) b=15878
+ *
+ * XXX Maxim: it's too weird to have this code here, in generic
+ * libcfs.h; platform-specific parts of libcfs should be responsible
+ * for providing proper for_each_possible_cpu macro
+ */
 #ifndef for_each_possible_cpu
 # ifdef for_each_cpu
 #  define for_each_possible_cpu(cpu) for_each_cpu(cpu)
@@ -113,10 +330,22 @@ static inline int __is_po2(unsigned long
 # endif
 #endif
 
-/* libcfs tcpip */
+/** \addtogroup libcfs_net
+ * @{
+ * \addtogroup libcfs_kernel_net
+ * @{ */
+
+/* enumerating and querying IP-interfaces */
 int libcfs_ipif_query(char *name, int *up, __u32 *ip, __u32 *mask);
 int libcfs_ipif_enumerate(char ***names);
 void libcfs_ipif_free_enumeration(char **names, int n);
+
+/* XXX Maxim: All APIs below excepting getbuf/setbuf are used in
+ * acceptor.c that has one implementation both for kernel and
+ * user-space. So, these APIs below should be factored out of
+ * #ifdef __KERNEL__ ... #endif. They are generic. */
+
+/* libcfs tcpip */
 int libcfs_sock_listen(cfs_socket_t **sockp, __u32 ip, int port, int backlog);
 int libcfs_sock_accept(cfs_socket_t **newsockp, cfs_socket_t *sock);
 void libcfs_sock_abort_accept(cfs_socket_t *sock);
@@ -129,110 +358,331 @@ int libcfs_sock_getaddr(cfs_socket_t *so
 int libcfs_sock_write(cfs_socket_t *sock, void *buffer, int nob, int timeout);
 int libcfs_sock_read(cfs_socket_t *sock, void *buffer, int nob, int timeout);
 void libcfs_sock_release(cfs_socket_t *sock);
+/** @} libcfs_kernel_net */
+/** @} libcfs_net */
 
-/* libcfs watchdogs */
+/** \addtogroup libcfs_watchdog
+ * @{ */
 struct lc_watchdog;
 
-/* Add a watchdog which fires after "time" milliseconds of delay.  You have to
- * touch it once to enable it. */
+/** Add a watchdog which fires after "time" milliseconds of delay.
+ * You have to touch it once to enable it. */
 struct lc_watchdog *lc_watchdog_add(int time,
                                     void (*cb)(pid_t pid, void *),
                                     void *data);
 
-/* Enables a watchdog and resets its timer. */
+/** Enables a watchdog and resets its timer. */
 void lc_watchdog_touch(struct lc_watchdog *lcw, int timeout);
 #define GET_TIMEOUT(svc) (max_t(int, obd_timeout,                       \
                           AT_OFF ? 0 : at_get(&svc->srv_at_estimate)) * \
                           svc->srv_watchdog_factor)
 
-/* Disable a watchdog; touch it to restart it. */
+/** Disable a watchdog; touch it to restart it. */
 void lc_watchdog_disable(struct lc_watchdog *lcw);
 
-/* Clean up the watchdog */
+/** Clean up the watchdog */
 void lc_watchdog_delete(struct lc_watchdog *lcw);
 
-/* Dump a debug log */
+/** Dump a debug log. It's the default callback to call when
+ * watchdog is triggered */
 void lc_watchdog_dumplog(pid_t pid, void *data);
 
+/** @} libcfs_watchdog */
+
 #endif /* __KERNEL__ */
 
-/* need both kernel and user-land acceptor */
+/*
+ * need both kernel and user-land acceptor
+ *
+ * XXX Maxim: These defines have nothing to do with libcfs API. Only
+ * LNET acceptor, ksocklnd and usocklnd need them. To be moved to
+ * generic lnet.h
+ */
 #define LNET_ACCEPTOR_MIN_RESERVED_PORT    512
 #define LNET_ACCEPTOR_MAX_RESERVED_PORT    1023
 
-/*
- * libcfs pseudo device operations
+/**
+ * \defgroup libcfs_ioctl Pseudo devices and ioctls support
+ * Generic API to support ioctls and manipulating pseudo-devices.
+ *
+ * Libcfs provides two levels of support for ioctls:
+ *
+ * 1. Ioctls that land on /dev/lnet device
+ *
+ * Libcfs creates and maintains /dev/lnet internally providing very
+ * simple API for consumers who need to handle ioctls coming via
+ * /dev/lnet. A consumer only needs to register its ioctl-handlers of
+ * \a libcfs_ioctl_handler type with libcfs_register_ioctl call on
+ * startup and unregister it with libcfs_deregister_ioctl on shutdown.
+ *
+ * Libcfs maintains the list of all registered ioctl-handlers using
+ * global \a ioctl_list as list-head. Whenever a user issues an ioctl on
+ * /dev/lnet, Libcfs firstly checks its \a cmd for values that can be
+ * handled internally (like IOC_LIBCFS_MARK_DEBUG, IOC_LIBCFS_CLEAR_DEBUG
+ * and some others), and, if it cannot, iterates over \a ioctl_list
+ * calling registered handlers one by one until some handler recognizes
+ * \a cmd returning rc != -EINVAL.
  *
- * struct cfs_psdev_t and
- * cfs_psdev_register() and
- * cfs_psdev_deregister() are declared in
- * libcfs/<os>/<os>-prim.h
+ * Libcfs also provides generic way to pass ioctl data to and from
+ * user-space calling libcfs_ioctl_getdata when an ioctl arrives and
+ * libcfs_ioctl_popdata when ioctl handling is complete. This requires
+ * using \a libcfs_ioctl_data structure as ioctl data both on
+ * user-space side issuing ioctls and kernel-space ioctl-handlers. So,
+ * both user-space and kernel handlers must share libcfs conventions
+ * of \a libcfs_ioctl_data content. See implementation of
+ * libcfs_ioctl_is_invalid, libcfs_ioctl_getdata and
+ * libcfs_ioctl_popdata for details.
  *
- * It's just draft now.
+ * Note, that libcfs_ioctl.h defines all ioctls handled via /dev/lnet
+ * device. The rationale is avoidance of overlap that could happen if
+ * every consumer defined \a cmd values on its own.
+ *
+ * 2. Any other ioctls
+ *
+ * Supporting ioctls for devices other than /dev/lnet requires
+ * creation of such devices first of all. Platform-specific libcfs
+ * files defines cfs_psdev_t type as an entity that can be registered
+ * in kernel to create /dev/something visible from user-space. They
+ * also provides register/unregister primitives to deal with
+ * cfs_psdev_t:
+ * - cfs_psdev_register
+ * - cfs_psdev_deregister
+ *
+ * It's responsibility of consumer of Libcfs to instantiate a sample
+ * of cfs_psdev_t, register and unregister it with the primitives
+ * above. Usually, cfs_psdev_t bears the name of pseudo-device (what
+ * will appear in /dev subtree) and the set of callbacks to be
+ * called by kernel whenever an user issues open/ioctl/close syscall
+ * on /dev/name_of_pseudo_device. The implementation of these
+ * callbacks is platform- and consumer-specific but usually they just
+ * call another callbacks - ones defined in \a cfs_psdev_ops structure
+ * correspondent to given pseudo-device. \a cfs_psdev_ops is not
+ * platform-specific and consumer may define it in common c-files.
+ *
+ * \a cfs_psdev_ops bears open/ioctl/close callbacks to be called from
+ * platform-specific consumer code whenever correspondent events
+ * happen. open/close callbacks may be implemented as bare
+ * PORTAL_MODULE_USE/PORTAL_MODULE_UNUSE (to avoid modunload in the
+ * middle of operation) if consumer doesn't need user-state
+ * info. ioctl callback is usually big switch over all allowed \a cmd
+ * values.
+ *
+ * The main consumer of facility explained above is Libcfs
+ * itself. Libcfs uses the same technique to create and maintain
+ * /dev/lnet as it provides for external consumers. Note that unlike
+ * to other consumers, Libcfs does need user-state info preserved
+ * across syscalls to handle ioctl(IOC_LIBCFS_MEMHOG)
+ * correctly. User-state feature works for this purpose as follows:
+ *
+ * - platform-specific libcfs open callback provides some storage to store
+ * a pointer to user-state info and passes its address as the second
+ * argument to common libcfs open callback. This storage resides in
+ * kernel, it is bound to open file descriptor and preserved across
+ * syscalls by kernel.
+ * - common libcfs open callback allocates user-state info of type
+ * \a libcfs_device_userstate and save its address where the second
+ * argument specifies.
+ * - when ioctl(IOC_LIBCFS_MEMHOG) comes, platform-specific libcfs
+ * ioctl callback creates an instance of \a cfs_psdev_file structure
+ * and copies the address of user-state info from the in-kernel
+ * storage to this instance. Then, it calls libcfs common ioctl
+ * callback passing the address of newly created and filled \a cfs_psdev_t
+ * as the first argument.
+ * - common libcfs ioctl callback interprets the first argument as
+ * pointer to \a libcfs_device_userstate structure (i.e. user-state
+ * info) and saves number of allocated memhog pages and pointer to the
+ * root memhog page int its fields
+ * - even if user-space process issuing ioctl(IOC_LIBCFS_MEMHOG)
+ * aborted, the kernel guarantees that file descriptor of /dev/lnet
+ * will be closed and libcfs platform-specific close callback
+ * called. The latter gets the address of user-state info from
+ * in-kernel storage and passes it as the second argument to common
+ * libcfs close callback.
+ * - common libcfs close callback interprets the second argument as
+ * pointer to \a libcfs_device_userstate structure (i.e. user-state
+ * info) and releases memhog pages according to the values stored in
+ * the fields of \a libcfs_device_userstate.
+ *
+ * @{
  */
 
+/**
+ * libcfs pseudo device file descriptor
+ *
+ * Libcfs ensures that cfs_psdev_ops::ioctl will be called with
+ * pointer to \a cfs_psdev_file whose \a private_data field is initialized
+ * with the same pointer that cfs_psdev_ops::open previously stored
+ * dereferencing its second argument.
+ */
 struct cfs_psdev_file {
+        /** not used */
         unsigned long   off;
+        /** The address of storage persistent across syscalls.
+         * \a cfs_psdev_ops methods may store address of user-state
+         * info in that storage */
         void            *private_data;
+        /** reserved for future use */
         unsigned long   reserved1;
+        /** reserved for future use */
         unsigned long   reserved2;
 };
 
+/**
+ * libcfs pseudo device operations
+ *
+ * Callbacks registered in this structure are being called while
+ * processing file operation on /dev/something device as follows:
+ * user-space open/ioctl/close syscall -->
+ *    kernel system handler of open/ioctl/close -->
+ *        libcfs platform-specific open/ioctl/close callback
+ *        registered in \a cfs_psdev_t -->
+ *            open/ioctl/close callback registered in \a cfs_psdev_ops.
+ */
 struct cfs_psdev_ops {
+        /** open callback to be called by platform-specific libcfs */
         int (*p_open)(unsigned long, void *);
+        /** close callback to be called by platform-specific libcfs */
         int (*p_close)(unsigned long, void *);
+        /** not used */
         int (*p_read)(struct cfs_psdev_file *, char *, unsigned long);
+        /** not used */
         int (*p_write)(struct cfs_psdev_file *, char *, unsigned long);
+        /** ioctl callback to be called by platform-specific libcfs */
         int (*p_ioctl)(struct cfs_psdev_file *, unsigned long, void *);
 };
 
-/*
- * Universal memory allocator API
+/** @} libcfs_ioctl */
+
+/**
+ * \defgroup libcfs_mem Memory Allocations
+ * Generic API for memory allocations.
+ *
+ * The API includes:
+ *
+ * - cfs_page_t as a generic wrapper around platform-specific native
+ * page structure along with routines to alloc, free, map, unmap and
+ * get its address.
+ * - general memory allocation routines to alloc and free a memory
+ * buffer of given size.
+ * - cfs_mem_cache_t - memory cache structure (SLAB allocator) along
+ * with routines to alloc, free, create and destroy it.
+ * - the set of universal flags to control allocator behavior and the
+ * type of memory allocated (like whether allocator can block, whether
+ * the kernel can start disk I/O for allocated buffer, etc.)
+ *
+ * Usage of libcfs page:
+ * - a page can be allocated with cfs_alloc_page
+ * - an array of pages can be allocated with cfs_alloc_pages
+ * - allocated page should be returned after use with cfs_free_page
+ * - allocated array of pages should be returned after use with cfs_free_pages
+ * - an allocated page can be mapped (i.e. associated with vaddr) with
+ * cfs_kmap
+ * - if page is mapped, the caller can get its vaddr with
+ * cfs_page_address
+ * - mapped page should be unmapped when its vaddr is not in use anymore
+ * with cfs_kunmap
+ *
+ * Usage of libcfs memory cache:
+ * - a cache can be created with cfs_mem_cache_create
+ * - created cache should be released after use with cfs_mem_cache_destroy
+ * - if a cache is created, the caller can allocate an object from
+ * this cache with cfs_mem_cache_alloc and return it after use with
+ * cfs_mem_cache_free. The object is just a chunk of virtual memory of
+ * given size specified by its vaddr.
+ * - the caller can get an imprecise hint whether given vaddr was
+ * allocated in the cache with cfs_mem_is_in_cache.
+ *
+ * @{
+ */
+
+/**
+ * Universal memory allocator flags
  */
 enum cfs_alloc_flags {
-        /* allocation is not allowed to block */
+        /** allocation is not allowed to block */
         CFS_ALLOC_ATOMIC = 0x1,
-        /* allocation is allowed to block */
+        /** allocation is allowed to block */
         CFS_ALLOC_WAIT   = 0x2,
-        /* allocation should return zeroed memory */
+        /** allocation should return zeroed memory */
         CFS_ALLOC_ZERO   = 0x4,
-        /* allocation is allowed to call file-system code to free/clean
+        /** allocation is allowed to call file-system code to free/clean
          * memory */
         CFS_ALLOC_FS     = 0x8,
-        /* allocation is allowed to do io to free/clean memory */
+        /** allocation is allowed to do io to free/clean memory */
         CFS_ALLOC_IO     = 0x10,
-        /* don't report allocation failure to the console */
+        /** don't report allocation failure to the console */
         CFS_ALLOC_NOWARN = 0x20,
-        /* standard allocator flag combination */
+        /** standard allocator flag combination */
         CFS_ALLOC_STD    = CFS_ALLOC_FS | CFS_ALLOC_IO,
+        /** flag combination for user process memory */
         CFS_ALLOC_USER   = CFS_ALLOC_WAIT | CFS_ALLOC_FS | CFS_ALLOC_IO,
 };
 
-/* flags for cfs_page_alloc() in addition to enum cfs_alloc_flags */
+/** flags for cfs_page_alloc() in addition to enum cfs_alloc_flags */
 enum cfs_alloc_page_flags {
-        /* allow to return page beyond KVM. It has to be mapped into KVM by
-         * cfs_page_map(); */
+        /** allow to return page beyond KVM. It has to be mapped into KVM by
+         * cfs_kmap(); */
         CFS_ALLOC_HIGH   = 0x40,
+        /** combines ::CFS_ALLOC_HIGH and ::CFS_ALLOC_USER */
         CFS_ALLOC_HIGHUSER = CFS_ALLOC_WAIT | CFS_ALLOC_FS | CFS_ALLOC_IO | CFS_ALLOC_HIGH,
 };
+/** @} libcfs_mem */
 
-/*
- * Drop into debugger, if possible. Implementation is provided by platform.
- */
+/** \addtogroup libcfs_misc
+ * @{ */
 
+/** Drop into debugger, if possible. Implementation is provided by platform. */
 void cfs_enter_debugger(void);
 
-/*
- * Defined by platform
+/**
+ * Convert server error code to client format.
+ * Error codes are from Linux errno.h.
+ */
+int convert_server_error(__u64 ecode);
+
+/** convert <fcntl.h> flag from client to server. */
+int convert_client_oflag(int cflag, int *result);
+
+/** @} libcfs_misc */
+
+/**
+ * \defgroup libcfs_signal Signal and daemonization
+ * Generic API for unix signals and daemonization (defined by platform)
+ *
+ * Daemonization assumes detaching from controlling terminal, blocking
+ * all signals, releasing file-system resources (like current working
+ * dir) and re-parenting to 'init' unix process.
+ *
+ * NOTE: Both cfs_daemonize and cfs_daemonize_ctxt daemonize caller,
+ * but consumer must use the latter if she is going to change task
+ * parameters related to file-system (like current working dir)
+ * afterwards. Otherwise, if given thread has nothing to do with
+ * file-system part of task, cfs_daemonize is enough.
+ *
+ * Signal-related primitives manipulates 'blocked signals' mask and
+ * 'pending' flag. 'blocked signals' mask defines which signals to
+ * block (i.e. don't pass to given task). The mask is represented by
+ * cfs_sigset_t type. 'pending' flag indicates that some signal is
+ * pending for given task (i.e. waits for delivery).
+ * @{
  */
+/** daemonize */
 void cfs_daemonize(char *str);
+/** daemonize and clone file-system part of task */
 int cfs_daemonize_ctxt(char *str);
+/** inquire current 'blocked signals' mask */
 cfs_sigset_t cfs_get_blocked_sigs(void);
+/** block all signals */
 cfs_sigset_t cfs_block_allsigs(void);
+/** block particular signals (\a bits); returns old mask */
 cfs_sigset_t cfs_block_sigs(cfs_sigset_t bits);
+/** restore mask to old value (to be passed as argument) */
 void cfs_restore_sigs(cfs_sigset_t);
+/** check if a signal waits for delivery */
 int cfs_signal_pending(void);
+/** clear 'pending' flag */
 void cfs_clear_sigpending(void);
+
 /*
  * XXX Liang:
  * these macros should be removed in the future,
@@ -242,30 +692,81 @@ void cfs_clear_sigpending(void);
 #define libcfs_daemonize(s)     cfs_daemonize(s)
 #define cfs_sigmask_lock(f)     do { f= 0; } while (0)
 #define cfs_sigmask_unlock(f)   do { f= 0; } while (0)
+/** @} libcfs_signal */
 
-int convert_server_error(__u64 ecode);
-int convert_client_oflag(int cflag, int *result);
-
-/*
- * Stack-tracing filling.
+/** \defgroup libcfs_debug Debugging
+ * Various subsystems of Libcfs to alleviate debugging
+ * @{
+ * \defgroup libcfs_stack_trace Stack-tracing
+ * Generic API for filling and extracting stack-traces
+ * @{
  */
 
-/*
- * Platform-dependent data-type to hold stack frames.
- */
+/* XXX Maxim: Nobody uses this API for now. Should we eliminate this
+ * subsystem as obsoleted? */
+
+/** Platform-dependent data-type to hold stack frames. */
 struct cfs_stack_trace;
 
-/*
- * Fill @trace with current back-trace.
- */
+/** Fill \a trace with current back-trace. */
 void cfs_stack_trace_fill(struct cfs_stack_trace *trace);
 
-/*
- * Return instruction pointer for frame @frame_no. NULL if @frame_no is
+/**
+ * Extract info (instruction pointer) for certain frame.
+ * \param trace stack-trace
+ * \param frame_no which frame we're querying for
+ * \return instruction pointer for frame \a frame_no. NULL if \a frame_no is
  * invalid.
  */
 void *cfs_stack_trace_frame(struct cfs_stack_trace *trace, int frame_no);
 
+/** @} libcfs_stack_trace */
+/** @} libcfs_debug */
+
+/**
+ * \defgroup libcfs_fs File operations for kernel users
+ * Generic API for manipulating files in kernel
+ *
+ * At present, the API consists of four independent parts:
+ *
+ * 1) File type and routines to read/write a file:
+ * - cfs_file_t
+ * - cfs_filp_open
+ * - cfs_filp_close
+ * - cfs_filp_read
+ * - cfs_user_write
+ * - cfs_filp_fsync
+ * - cfs_get_file
+ * - cfs_put_file
+ * - cfs_file_count
+ * - cfs_filp_size
+ * - cfs_filp_poff
+ * - cfs_user_write
+ *
+ * 2) File-lock type and related functions:
+ * - cfs_flock_t
+ * - cfs_flock_type
+ * - cfs_flock_set_type
+ * - cfs_flock_pid
+ * - cfs_flock_set_pid
+ * - cfs_flock_start
+ * - cfs_flock_set_start
+ * - cfs_flock_end
+ * - cfs_flock_set_end
+ *
+ * 3) Types and macros to work with directories:
+ * - cfs_dentry_t
+ * - cfs_dirent_t
+ * - CFS_IFTODT
+ * - CFS_DTTOIF
+ *
+ * 4) Universal open flags and conversion routines (currently unused):
+ * - CFS_O_ACCMODE, CFS_O_CREAT, etc.
+ * - cfs_oflags2univ
+ * - cfs_univ2oflags
+ * @{
+ */
+
 /*
  * Universal open flags.
  */
@@ -285,11 +786,13 @@ void *cfs_stack_trace_frame(struct cfs_s
 #define CFS_O_NOFOLLOW          0400000
 #define CFS_O_NOATIME           01000000
 
-/* convert local open flags to universal open flags */
+/** convert local open flags to universal open flags */
 int cfs_oflags2univ(int flags);
-/* convert universal open flags to local open flags */
+/** convert universal open flags to local open flags */
 int cfs_univ2oflags(int flags);
 
+/** @} libcfs_fs */
+
 #include <libcfs/libcfs_debug.h>
 #include <libcfs/libcfs_private.h>
 #include <libcfs/libcfs_ioctl.h>
@@ -299,7 +802,10 @@ int cfs_univ2oflags(int flags);
 #include <libcfs/libcfs_kernelcomm.h>
 #include <libcfs/libcfs_hash.h>
 
-/* container_of depends on "likely" which is defined in libcfs_private.h */
+/** \addtogroup libcfs_misc
+ * @{ */
+
+/** container_of depends on "likely" which is defined in libcfs_private.h */
 static inline void *__container_of(void *ptr, unsigned long shift)
 {
         if (unlikely(IS_ERR(ptr) || ptr == NULL))
@@ -308,9 +814,12 @@ static inline void *__container_of(void 
                 return (char *)ptr - shift;
 }
 
+/** the same as ::container_of, but also checks validity of \a ptr */
 #define container_of0(ptr, type, member) \
         ((type *)__container_of((void *)(ptr), offsetof(type, member)))
+/** @} libcfs_misc */
 
 #define _LIBCFS_H
 
+/** @} libcfs */
 #endif /* _LIBCFS_H */
